#[macro_use]
extern crate lazy_static;
#[macro_use]
extern crate serde_derive;
#[macro_use]
extern crate diesel;
#[macro_use]
extern crate diesel_migrations;
use actix_session::CookieSession;
use actix_web::cookie::SameSite;
use actix_files::Files;
use actix_web::client::Client;
use actix_web::{web, App, FromRequest, HttpServer};
use diesel::prelude::*;
use url::Url;
use crate::config::CONFIG;
use crate::config::PAYLOAD_LIMIT;
use crate::forward::*;
mod config;
mod errors;
mod forward;
mod sniff;
mod templates;


#[actix_web::main]
async fn main() -> std::io::Result<()> {
    /*    std::env::set_var("RUST_LOG", "actix_web=debug");
    env_logger::init();*/
    println!("ta ta tala ~ SNCF init");
    println!("Checking configuration file...");
    CONFIG.check_version();
    println!(
        "Now listening at {}:{}",
        CONFIG.listening_address, CONFIG.listening_port
    );

    // starting the http server
    HttpServer::new(move || {
        App::new()
            .data(Client::new())
	    .data(forward_url.clone())
            //.wrap(
            //    CookieSession::signed(&[0; 32])
            //    .secure(true)
            //    .same_site(SameSite::Strict)
            //    .http_only(true)
             //   .name("pluriton_cookies")
             //   )
            .service(Files::new("/assets/", "./templates/assets/").index_file("index.html"))
            .route("/", web::get().to(index))
            .route("/link/text", web::post().to(forward_register))
            .default_service(web::route().to(forward))
            .data(String::configure(|cfg| cfg.limit(PAYLOAD_LIMIT)))
            .app_data(actix_web::web::Bytes::configure(|cfg| {
                cfg.limit(PAYLOAD_LIMIT)
            }))
    })
    .bind((CONFIG.listening_address.as_str(), CONFIG.listening_port))?
    .system_exit()
    .run()
    .await
}

pub fn debug(text: &str) {
    if CONFIG.debug_mode {
        println!("{}", text);
    }
}
